var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
var st = Object.defineProperty;
var it = (r, t, e) => t in r ? st(r, t, { enumerable: true, configurable: true, writable: true, value: e }) : r[t] = e;
var c = (r, t, e) => it(r, typeof t != "symbol" ? t + "" : t, e);
function ot(r, t = false) {
  if (r == null) throw new Error("Cannot clean a NULL value");
  return Array.isArray(r) ? r = r.filter((e) => e != null) : Object.entries(r).forEach(([e, n]) => {
    (t && n === void 0 || !t && n == null) && delete r[e];
  }), r;
}
function O(r, t) {
  const e = typeof r, n = typeof t;
  return e != "object" || r == null || n != "object" || t == null ? e == "function" && n == "function" ? r.toString() == t.toString() : r === t : Object.keys(r).length != Object.keys(t).length ? false : Object.keys(r).every((i) => O(r[i], t[i]));
}
function I(r) {
  try {
    return JSON.parse(r);
  } catch {
    return r;
  }
}
function Ot(r, t) {
  let e = [];
  return JSON.stringify(r, (n, s) => {
    if (typeof s == "object" && s !== null) {
      if (e.includes(s)) return;
      e.push(s);
    }
    return s;
  }, t);
}
function m(r) {
  return Array.isArray(r) ? r : [r];
}
class S extends Array {
  /** Number of elements in set */
  get size() {
    return this.length;
  }
  /**
   * Array to create set from, duplicate values will be removed
   * @param {T[]} elements Elements which will be added to set
   */
  constructor(t = []) {
    super(), t != null && t.forEach && t.forEach((e) => this.add(e));
  }
  /**
   * Add elements to set if unique
   * @param items
   */
  add(...t) {
    t.filter((e) => !this.has(e)).forEach((e) => this.push(e));
  }
  /**
   * Delete elements from set
   * @param items Elements that will be deleted
   */
  delete(...t) {
    t.forEach((e) => {
      const n = this.indexOf(e);
      n != -1 && this.slice(n, 1);
    });
  }
  /**
   * Create list of elements this set has which the comparison set does not
   * @param {ASet<T>} set Set to compare against
   * @return {ASet<T>} Different elements
   */
  difference(t) {
    return new S(this.filter((e) => !t.has(e)));
  }
  /**
   * Check if set includes element
   * @param {T} el Element to look for
   * @return {boolean} True if element was found, false otherwise
   */
  has(t) {
    return this.indexOf(t) != -1;
  }
  /**
   * Create list of elements this set has in common with the comparison set
   * @param {ASet<T>} set Set to compare against
   * @return {boolean} Set of common elements
   */
  intersection(t) {
    return new S(this.filter((e) => t.has(e)));
  }
  /**
   * Check if this set has no elements in common with the comparison set
   * @param {ASet<T>} set Set to compare against
   * @return {boolean} True if nothing in common, false otherwise
   */
  isDisjointFrom(t) {
    return this.intersection(t).size == 0;
  }
  /**
   * Check if all elements in this set are included in the comparison set
   * @param {ASet<T>} set Set to compare against
   * @return {boolean} True if all elements are included, false otherwise
   */
  isSubsetOf(t) {
    return this.findIndex((e) => !t.has(e)) == -1;
  }
  /**
   * Check if all elements from comparison set are included in this set
   * @param {ASet<T>} set Set to compare against
   * @return {boolean} True if all elements are included, false otherwise
   */
  isSuperset(t) {
    return t.findIndex((e) => !this.has(e)) == -1;
  }
  /**
   * Create list of elements that are only in one set but not both (XOR)
   * @param {ASet<T>} set Set to compare against
   * @return {ASet<T>} New set of unique elements
   */
  symmetricDifference(t) {
    return new S([...this.difference(t), ...t.difference(this)]);
  }
  /**
   * Create joined list of elements included in this & the comparison set
   * @param {ASet<T>} set Set join
   * @return {ASet<T>} New set of both previous sets combined
   */
  union(t) {
    return new S([...this, ...t]);
  }
}
class Tt {
  /**
   * Create new cache
   *
   * @param {keyof T} key Default property to use as primary key
   * @param options
   */
  constructor(t, e = {}) {
    c(this, "store", {});
    c(this, "complete", false);
    c(this, "values", this.all());
    if (this.key = t, this.options = e, e.storageKey && !e.storage && (e.storage = localStorage), e.storageKey && e.storage) {
      const n = e.storage.getItem(e.storageKey);
      if (n)
        try {
          Object.assign(this.store, JSON.parse(n));
        } catch {
        }
    }
    return new Proxy(this, {
      get: (n, s) => s in n ? n[s] : n.store[s],
      set: (n, s, i) => (s in n ? n[s] = i : n.store[s] = i, true)
    });
  }
  getKey(t) {
    if (!this.key) throw new Error("No key defined");
    return t[this.key];
  }
  /**
   * Get all cached items
   *
   * @return {T[]} Array of items
   */
  all() {
    return Object.values(this.store);
  }
  /**
   * Add a new item to the cache. Like set, but finds key automatically
   *
   * @param {T} value Item to add to cache
   * @param {number | undefined} ttl Override default expiry
   * @return {this}
   */
  add(t, e = this.ttl) {
    const n = this.getKey(t);
    return this.set(n, t, e), this;
  }
  /**
   * Add several rows to the cache
   *
   * @param {T[]} rows Several items that will be cached using the default key
   * @param complete Mark cache as complete & reliable, defaults to true
   * @return {this}
   */
  addAll(t, e = true) {
    return t.forEach((n) => this.add(n)), this.complete = e, this;
  }
  /**
   * Remove all keys from cache
   */
  clear() {
    this.store = {};
  }
  /**
   * Delete an item from the cache
   *
   * @param {K} key Item's primary key
   */
  delete(t) {
    delete this.store[t], this.options.storageKey && this.options.storage && this.options.storage.setItem(this.options.storageKey, JSON.stringify(this.store));
  }
  /**
   * Return cache as an array of key-value pairs
   * @return {[K, T][]} Key-value pairs array
   */
  entries() {
    return Object.entries(this.store);
  }
  /**
   * Get item from the cache
   * @param {K} key Key to lookup
   * @return {T} Cached item
   */
  get(t) {
    return this.store[t];
  }
  /**
   * Get a list of cached keys
   *
   * @return {K[]} Array of keys
   */
  keys() {
    return Object.keys(this.store);
  }
  /**
   * Get map of cached items
   *
   * @return {Record<K, T>}
   */
  map() {
    return structuredClone(this.store);
  }
  /**
   * Add an item to the cache manually specifying the key
   *
   * @param {K} key Key item will be cached under
   * @param {T} value Item to cache
   * @param {number | undefined} ttl Override default expiry in seconds
   * @return {this}
   */
  set(t, e, n = this.options.ttl) {
    return this.store[t] = e, this.options.storageKey && this.options.storage && this.options.storage.setItem(this.options.storageKey, JSON.stringify(this.store)), n && setTimeout(() => {
      this.complete = false, this.delete(t);
    }, n * 1e3), this;
  }
}
class x extends Promise {
  constructor(e) {
    super((n, s) => e(
      (i) => n(i),
      (i) => s(i),
      (i) => this.progress = i
    ));
    c(this, "listeners", []);
    c(this, "_progress", 0);
  }
  get progress() {
    return this._progress;
  }
  set progress(e) {
    e != this._progress && (this._progress = e, this.listeners.forEach((n) => n(e)));
  }
  static from(e) {
    return e instanceof x ? e : new x((n, s) => e.then((...i) => n(...i)).catch((...i) => s(...i)));
  }
  from(e) {
    const n = x.from(e);
    return this.onProgress((s) => n.progress = s), n;
  }
  onProgress(e) {
    return this.listeners.push(e), this;
  }
  then(e, n) {
    const s = super.then(e, n);
    return this.from(s);
  }
  catch(e) {
    return this.from(super.catch(e));
  }
  finally(e) {
    return this.from(super.finally(e));
  }
}
function Dt(r, t) {
  r instanceof Blob || (r = new Blob(m(r)));
  const e = URL.createObjectURL(r);
  lt(e, t), URL.revokeObjectURL(e);
}
function lt(r, t) {
  const e = document.createElement("a");
  e.href = r, e.download = t || r.split("/").pop(), document.body.appendChild(e), e.click(), document.body.removeChild(e);
}
function Mt(r = {}) {
  return new Promise((t) => {
    const e = document.createElement("input");
    e.type = "file", e.accept = r.accept || "*", e.style.display = "none", e.multiple = !!r.multiple, e.onblur = e.onchange = async () => {
      t(Array.from(e.files)), e.remove();
    }, document.body.appendChild(e), e.click();
  });
}
function kt(r, t = /* @__PURE__ */ new Date()) {
  (typeof t == "number" || typeof t == "string") && (t = new Date(t));
  const e = `${t.getFullYear()}-${(t.getMonth() + 1).toString().padStart(2, "0")}-${t.getDate().toString().padStart(2, "0")}_${t.getHours().toString().padStart(2, "0")}-${t.getMinutes().toString().padStart(2, "0")}-${t.getSeconds().toString().padStart(2, "0")}`;
  return e;
}
function Pt(r) {
  return new x((t, e, n) => {
    const s = new XMLHttpRequest(), i = new FormData();
    r.files.forEach((o) => i.append("file", o)), s.withCredentials = !!r.withCredentials, s.upload.addEventListener("progress", (o) => o.lengthComputable ? n(o.loaded / o.total) : null), s.addEventListener("loadend", () => t(I(s.responseText))), s.addEventListener("error", () => e(I(s.responseText))), s.addEventListener("timeout", () => e({ error: "Request timed out" })), s.open("POST", r.url), Object.entries(r.headers || {}).forEach(([o, a]) => s.setRequestHeader(o, a)), s.send(i);
  });
}
class K {
  constructor() {
    c(this, "listeners", {});
  }
  static emit(t, ...e) {
    (this.listeners["*"] || []).forEach((n) => n(t, ...e)), (this.listeners[t.toString()] || []).forEach((n) => n(...e));
  }
  static off(t, e) {
    const n = t.toString();
    this.listeners[n] = (this.listeners[n] || []).filter((s) => s === e);
  }
  static on(t, e) {
    var s;
    const n = t.toString();
    return this.listeners[n] || (this.listeners[n] = []), (s = this.listeners[n]) == null || s.push(e), () => this.off(t, e);
  }
  static once(t, e) {
    return new Promise((n) => {
      const s = this.on(t, (...i) => {
        n(i.length == 1 ? i[0] : i), e && e(...i), s();
      });
    });
  }
  emit(t, ...e) {
    (this.listeners["*"] || []).forEach((n) => n(t, ...e)), (this.listeners[t] || []).forEach((n) => n(...e));
  }
  off(t, e) {
    this.listeners[t] = (this.listeners[t] || []).filter((n) => n === e);
  }
  on(t, e) {
    var n;
    return this.listeners[t] || (this.listeners[t] = []), (n = this.listeners[t]) == null || n.push(e), () => this.off(t, e);
  }
  once(t, e) {
    return new Promise((n) => {
      const s = this.on(t, (...i) => {
        n(i.length == 1 ? i[0] : i), e && e(...i), s();
      });
    });
  }
}
c(K, "listeners", {});
class g extends Error {
  constructor(e, n) {
    super(e);
    c(this, "_code");
    n != null && (this._code = n);
  }
  get code() {
    return this._code || this.constructor.code;
  }
  set code(e) {
    this._code = e;
  }
  static from(e) {
    const n = Number(e.statusCode) ?? Number(e.code), s = new this(e.message || e.toString());
    return Object.assign(s, {
      stack: e.stack,
      ...e,
      code: n ?? void 0
    });
  }
  static instanceof(e) {
    return e.constructor.code != null;
  }
  toString() {
    return this.message || super.toString();
  }
}
c(g, "code", 500);
class W extends g {
  constructor(t = "Bad Request") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(W, "code", 400);
class v extends g {
  constructor(t = "Unauthorized") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(v, "code", 401);
class J extends g {
  constructor(t = "Payment Required") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(J, "code", 402);
class z extends g {
  constructor(t = "Forbidden") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(z, "code", 403);
class Z extends g {
  constructor(t = "Not Found") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(Z, "code", 404);
class V extends g {
  constructor(t = "Method Not Allowed") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(V, "code", 405);
class X extends g {
  constructor(t = "Not Acceptable") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(X, "code", 406);
class Q extends g {
  constructor(t = "Internal Server Error") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(Q, "code", 500);
class _ extends g {
  constructor(t = "Not Implemented") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(_, "code", 501);
class tt extends g {
  constructor(t = "Bad Gateway") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(tt, "code", 502);
class et extends g {
  constructor(t = "Service Unavailable") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(et, "code", 503);
class rt extends g {
  constructor(t = "Gateway Timeout") {
    super(t);
  }
  static instanceof(t) {
    return t.constructor.code == this.code;
  }
}
c(rt, "code", 504);
const E = class E2 {
  constructor(t = {}) {
    c(this, "interceptors", {});
    c(this, "headers", {});
    c(this, "url");
    this.url = t.url ?? null, this.headers = t.headers || {}, t.interceptors && t.interceptors.forEach((e) => E2.addInterceptor(e));
  }
  static addInterceptor(t) {
    const e = Object.keys(E2.interceptors).length.toString();
    return E2.interceptors[e] = t, () => {
      E2.interceptors[e] = null;
    };
  }
  addInterceptor(t) {
    const e = Object.keys(this.interceptors).length.toString();
    return this.interceptors[e] = t, () => {
      this.interceptors[e] = null;
    };
  }
  request(t = {}) {
    var s;
    if (!this.url && !t.url) throw new Error("URL needs to be set");
    let e = ((s = t.url) != null && s.startsWith("http") ? t.url : (this.url || "") + (t.url || "")).replace(/([^:]\/)\/+/g, "$1");
    if (t.fragment && (e.includes("#") ? e.replace(/#.*(\?|\n)/g, (i, o) => `#${t.fragment}${o}`) : e += "#" + t.fragment), t.query) {
      const i = Array.isArray(t.query) ? t.query : Object.keys(t.query).map((o) => ({ key: o, value: t.query[o] }));
      e += (e.includes("?") ? "&" : "?") + i.map((o) => `${o.key}=${o.value}`).join("&");
    }
    const n = ot({
      "Content-Type": t.body ? t.body instanceof FormData ? "multipart/form-data" : "application/json" : void 0,
      ...E2.headers,
      ...this.headers,
      ...t.headers
    });
    return typeof t.body == "object" && t.body != null && n["Content-Type"] == "application/json" && (t.body = JSON.stringify(t.body)), new x((i, o, a) => {
      try {
        fetch(e, {
          headers: n,
          method: t.method || (t.body ? "POST" : "GET"),
          body: t.body
        }).then(async (u) => {
          var G, U;
          for (let l of [...Object.values(E2.interceptors), ...Object.values(this.interceptors)])
            await new Promise((C) => l(u, () => C()));
          const $ = u.headers.get("Content-Length"), j = $ ? parseInt($, 10) : 0;
          let P = 0;
          const T = (G = u.body) == null ? void 0 : G.getReader(), nt = new ReadableStream({
            start(l) {
              function C() {
                T == null || T.read().then((A) => {
                  if (A.done) return l.close();
                  P += A.value.byteLength, a(P / j), l.enqueue(A.value), C();
                }).catch((A) => l.error(A));
              }
              C();
            }
          });
          if (u.data = new Response(nt), t.decode == null || t.decode) {
            const l = (U = u.headers.get("Content-Type")) == null ? void 0 : U.toLowerCase();
            l != null && l.includes("form") ? u.data = await u.data.formData() : l != null && l.includes("json") ? u.data = await u.data.json() : l != null && l.includes("text") ? u.data = await u.data.text() : l != null && l.includes("application") && (u.data = await u.data.blob());
          }
          u.ok ? i(u) : o(u);
        }).catch((u) => o(u));
      } catch (u) {
        o(u);
      }
    });
  }
};
c(E, "interceptors", {}), c(E, "headers", {});
let F = E;
const R = {
  CLEAR: "\x1B[0m",
  BRIGHT: "\x1B[1m",
  DIM: "\x1B[2m",
  UNDERSCORE: "\x1B[4m",
  BLINK: "\x1B[5m",
  REVERSE: "\x1B[7m",
  HIDDEN: "\x1B[8m"
}, L = {
  BLACK: "\x1B[30m",
  RED: "\x1B[31m",
  GREEN: "\x1B[32m",
  YELLOW: "\x1B[33m",
  BLUE: "\x1B[34m",
  MAGENTA: "\x1B[35m",
  CYAN: "\x1B[36m",
  LIGHT_GREY: "\x1B[37m",
  GREY: "\x1B[90m",
  LIGHT_RED: "\x1B[91m",
  LIGHT_GREEN: "\x1B[92m",
  LIGHT_YELLOW: "\x1B[93m",
  LIGHT_BLUE: "\x1B[94m",
  LIGHT_MAGENTA: "\x1B[95m",
  LIGHT_CYAN: "\x1B[96m",
  WHITE: "\x1B[97m"
};
var ft = /* @__PURE__ */ ((r) => (r[r.ERROR = 0] = "ERROR", r[r.WARN = 1] = "WARN", r[r.INFO = 2] = "INFO", r[r.LOG = 3] = "LOG", r[r.DEBUG = 4] = "DEBUG", r))(ft || {});
const w = class w2 extends K {
  constructor(t) {
    super(), this.namespace = t;
  }
  pad(t, e, n, s = false) {
    const i = t.toString(), o = e - i.length;
    if (o <= 0) return i;
    const a = Array(~~(o / n.length)).fill(n).join("");
    return s ? i + a : a + i;
  }
  format(...t) {
    const e = /* @__PURE__ */ new Date();
    return `${`${e.getFullYear()}-${e.getMonth() + 1}-${e.getDate()} ${this.pad(e.getHours().toString(), 2, "0")}:${this.pad(e.getMinutes().toString(), 2, "0")}:${this.pad(e.getSeconds().toString(), 2, "0")}.${this.pad(e.getMilliseconds().toString(), 3, "0", true)}`}${this.namespace ? ` [${this.namespace}]` : ""} ${t.join(" ")}`;
  }
  debug(...t) {
    if (w2.LOG_LEVEL < 4) return;
    const e = this.format(...t);
    w2.emit(4, e), console.debug(L.LIGHT_GREY + e + R.CLEAR);
  }
  log(...t) {
    if (w2.LOG_LEVEL < 3) return;
    const e = this.format(...t);
    w2.emit(3, e), console.log(R.CLEAR + e);
  }
  info(...t) {
    if (w2.LOG_LEVEL < 2) return;
    const e = this.format(...t);
    w2.emit(2, e), console.info(L.BLUE + e + R.CLEAR);
  }
  warn(...t) {
    if (w2.LOG_LEVEL < 1) return;
    const e = this.format(...t);
    w2.emit(1, e), console.warn(L.YELLOW + e + R.CLEAR);
  }
  error(...t) {
    if (w2.LOG_LEVEL < 0) return;
    const e = this.format(...t);
    w2.emit(0, e), console.error(L.RED + e + R.CLEAR);
  }
};
c(w, "LOG_LEVEL", 4);
function ee(r, ...t) {
  const e = [];
  for (let n = 0; n < r.length || n < t.length; n++)
    r[n] && e.push(r[n]), t[n] && e.push(t[n]);
  return new y(e.join(""));
}
function mt(r, ...t) {
  let e = [];
  for (let i = 0; i < r.length || i < t.length; i++)
    r[i] && e.push(r[i]), t[i] && e.push(t[i]);
  const [n, s] = e.join("").split(":");
  return y.toString(n, s == null ? void 0 : s.split(""));
}
class y {
  constructor(t) {
    c(this, "module");
    c(this, "fullPath");
    c(this, "path");
    c(this, "name");
    c(this, "methods");
    c(this, "all");
    c(this, "none");
    c(this, "create");
    c(this, "read");
    c(this, "update");
    c(this, "delete");
    var o;
    if (typeof t == "object") return Object.assign(this, t);
    let [e, n, s] = t.split(":");
    s || (s = n || "*"), (e == "*" || !e && s == "*") && (e = "", s = "*");
    let i = e.split("/").filter((a) => !!a);
    this.module = ((o = i.splice(0, 1)[0]) == null ? void 0 : o.toLowerCase()) || "", this.fullPath = e, this.path = i.join("/"), this.name = i.pop() || "", this.methods = s.split(""), this.all = s == null ? void 0 : s.includes("*"), this.none = s == null ? void 0 : s.includes("n"), this.create = !(s != null && s.includes("n")) && ((s == null ? void 0 : s.includes("*")) || (s == null ? void 0 : s.includes("w")) || (s == null ? void 0 : s.includes("c"))), this.read = !(s != null && s.includes("n")) && ((s == null ? void 0 : s.includes("*")) || (s == null ? void 0 : s.includes("r"))), this.update = !(s != null && s.includes("n")) && ((s == null ? void 0 : s.includes("*")) || (s == null ? void 0 : s.includes("w")) || (s == null ? void 0 : s.includes("u"))), this.delete = !(s != null && s.includes("n")) && ((s == null ? void 0 : s.includes("*")) || (s == null ? void 0 : s.includes("w")) || (s == null ? void 0 : s.includes("d")));
  }
  /**
   * Combine multiple  events into one parsed object. Longest path takes precedent, but all subsequent methods are
   * combined until a "none" is reached
   *
   * @param {string | PathEvent} paths Events as strings or pre-parsed
   * @return {PathEvent} Final combined permission
   */
  static combine(t) {
    let e = false;
    const n = t.map((s) => new y(s)).toSorted((s, i) => {
      const o = s.fullPath.length, a = i.fullPath.length;
      return o < a ? 1 : o > a ? -1 : 0;
    }).reduce((s, i) => (i.none && (e = true), s ? (e || (i.all && (s.all = true), (i.all || i.create) && (s.create = true), (i.all || i.read) && (s.read = true), (i.all || i.update) && (s.update = true), (i.all || i.delete) && (s.delete = true), s.methods = [...s.methods, ...i.methods]), s) : i), null);
    return n.all && (n.methods = ["*"]), n.none && (n.methods = ["n"]), n.methods = new S(n.methods), n.raw = mt`${n.fullPath}:${n.methods}`, n;
  }
  /**
   * Squash 2 sets of paths & return true if any overlap is found
   *
   * @param {string | PathEvent | (string | PathEvent)[]} target Array of Events as strings or pre-parsed
   * @param has Target must have at least one of these path
   * @return {boolean} Whether there is any overlap
   */
  static has(t, ...e) {
    const n = m(e).map((i) => new y(i)), s = m(t).map((i) => new y(i));
    return !!n.find((i) => {
      if (!i.fullPath && i.all) return true;
      const o = s.filter((u) => i.fullPath.startsWith(u.fullPath));
      if (!o.length) return false;
      const a = y.combine(o);
      return !a.none && (a.all || new S(a.methods).intersection(new S(i.methods)).length);
    });
  }
  /**
   * Squash 2 sets of paths & return true if the target has all paths
   *
   * @param {string | PathEvent | (string | PathEvent)[]} target Array of Events as strings or pre-parsed
   * @param has Target must have all these paths
   * @return {boolean} Whether there is any overlap
   */
  static hasAll(t, ...e) {
    return e.filter((n) => y.has(t, n)).length == e.length;
  }
  /**
   * Same as `has` but raises an error if there is no overlap
   *
   * @param {string | string[]} target Array of Events as strings or pre-parsed
   * @param has Target must have at least one of these path
   */
  static hasFatal(t, ...e) {
    if (!y.has(t, ...e)) throw new Error(`Requires one of: ${m(e).join(", ")}`);
  }
  /**
   * Same as `hasAll` but raises an error if the target is missing any paths
   *
   * @param {string | string[]} target Array of Events as strings or pre-parsed
   * @param has Target must have all these paths
   */
  static hasAllFatal(t, ...e) {
    if (!y.hasAll(t, ...e)) throw new Error(`Requires all: ${m(e).join(", ")}`);
  }
  /**
   * Create  event string from its components
   *
   * @param {string | string[]} path Event path
   * @param {Method} methods Event method
   * @return {string} String representation of Event
   */
  static toString(t, e) {
    let n = m(t).filter((s) => s != null).join("/");
    return e != null && e.length && (n += `:${m(e).map((s) => s.toLowerCase()).join("")}`), n == null ? void 0 : n.trim().replaceAll(/\/{2,}/g, "/").replaceAll(/(^\/|\/$)/g, "");
  }
  /**
   * Create  event string from its components
   *
   * @return {string} String representation of Event
   */
  toString() {
    return y.toString(this.fullPath, this.methods);
  }
}
class re {
  constructor() {
    c(this, "listeners", []);
  }
  emit(t, ...e) {
    const n = new y(t);
    this.listeners.filter((s) => y.has(s[0], t)).forEach(async (s) => s[1](n, ...e));
  }
  off(t) {
    this.listeners = this.listeners.filter((e) => e[1] != t);
  }
  on(t, e) {
    return m(t).forEach((n) => this.listeners.push([new y(n), e])), () => this.off(e);
  }
  once(t, e) {
    return new Promise((n) => {
      const s = this.on(t, (i, ...o) => {
        n(o.length < 2 ? o[0] : o), e && e(i, ...o), s();
      });
    });
  }
  relayEvents(t) {
    t.on("*", (e, ...n) => this.emit(e, ...n));
  }
}
class Api extends F {
  constructor(url = location.origin, opts = {}) {
    super({ ...(opts == null ? void 0 : opts.http) || {}, url });
    __publicField(this, "emitter", new re());
    __publicField(this, "pending", {});
    __publicField(this, "storageKey");
    __publicField(this, "host");
    __publicField(this, "_token", null);
    __publicField(this, "emit", this.emitter.emit.bind(this.emitter));
    __publicField(this, "off", this.emitter.off.bind(this.emitter));
    __publicField(this, "on", this.emitter.on.bind(this.emitter));
    __publicField(this, "once", this.emitter.once.bind(this.emitter));
    __publicField(this, "relayEvents", this.emitter.relayEvents.bind(this.emitter));
    this.url = url;
    this.opts = opts;
    this.host = new URL(url).host;
    this.storageKey = `momentum:token:${this.host}`;
    if (opts.persist && localStorage) {
      const token = localStorage.getItem(this.storageKey);
      if (token) this.token = token;
    }
  }
  get token() {
    return this._token;
  }
  set token(token) {
    if (token == this._token) return;
    this._token = token;
    this.headers["Authorization"] = token ? `Bearer ${token}` : null;
    if (this.opts.persist && localStorage) {
      if (token) localStorage.setItem(this.storageKey, token);
      else localStorage.removeItem(this.storageKey);
    }
    this.emit(mt`api/token:${token ? "u" : "d"}`, token);
  }
  healthcheck() {
    return this.request({ url: "/api/healthcheck" }).then((resp) => {
      this.emit(mt`api/healthcheck:r`, resp);
      return resp;
    });
  }
  request(options) {
    const key = Ot(options);
    const method = options.method == "GET" ? "r" : options.method == "POST" ? "c" : options.method == "DELETE" ? "d" : "u";
    if (this.pending[key] != null) return this.pending[key];
    this.pending[key] = super.request(options).then((response) => {
      this.emit(mt`api/response:${method}`, { request: options, response });
      return response.data;
    }).catch((err) => {
      const e = (err == null ? void 0 : err.data) || err;
      this.emit(mt`api/error:${method}`, { request: options, error: e });
      throw e;
    }).finally(() => delete this.pending[key]);
    this.emit(mt`api/request:${method}`, { request: options, response: this.pending[key] });
    return this.pending[key];
  }
}
var ActionType = /* @__PURE__ */ ((ActionType2) => {
  ActionType2[ActionType2["CRON"] = 0] = "CRON";
  ActionType2[ActionType2["EVENT"] = 1] = "EVENT";
  ActionType2[ActionType2["DELETE"] = 2] = "DELETE";
  ActionType2[ActionType2["GET"] = 3] = "GET";
  ActionType2[ActionType2["PATCH"] = 4] = "PATCH";
  ActionType2[ActionType2["POST"] = 5] = "POST";
  ActionType2[ActionType2["PUT"] = 6] = "PUT";
  return ActionType2;
})(ActionType || {});
class Actions extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    __publicField(this, "cache", new Tt("_id"));
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  all() {
    return this.api.request({ url: `/api/` + mt`actions` }).then((resp) => {
      this.cache.addAll(resp);
      this.emit(mt`actions:r`, resp || []);
      return resp;
    });
  }
  delete(id) {
    if (!id) throw new Error("Cannot delete action, missing ID");
    return this.api.request({ url: `/api/` + mt`actions/${id}`, method: "DELETE" }).then(() => {
      this.cache.delete(id);
      this.emit(mt`actions/${id}:d`, id);
    });
  }
  read(id, reload = false) {
    if (!id) throw new Error("Cannot read action, missing ID");
    const cached = this.cache.get(id);
    if (!reload && cached) return Promise.resolve(cached);
    return this.api.request({ url: `/api/` + mt`actions/${id}` }).then((action) => {
      if (action) this.cache.add(action);
      this.emit(mt`actions/${id}:r`, action);
      return action;
    });
  }
  run(path, opts = {}) {
    if (!path) throw new Error("Cannot run action, missing path");
    return this.api.request({ url: `/api/` + mt`actions/run/${path}`, ...opts });
  }
  runById(action, opts = {}) {
    const id = typeof action == "string" ? action : action == null ? void 0 : action._id;
    if (!id) throw new Error("Cannot run action, missing ID");
    return this.api.request({ url: "/api/" + mt`actions/run-by-id/${id}`, method: "POST", ...opts });
  }
  update(action) {
    return this.api.request({
      url: `/api/` + mt`actions/${action._id}`,
      method: "POST",
      body: action
    }).then((action2) => {
      if (action2) this.cache.add(action2);
      this.emit(mt`actions/${action2._id}:u`, action2);
      return action2;
    });
  }
}
class Ai extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  ask(question, context) {
    if (!question) throw new Error("Cannot ask AI, missing question");
    return this.api.request({ url: `/api/` + mt`ai`, method: "POST", body: {
      question,
      context
    } }).then((response) => {
      this.emit(mt`ai:c`, { question, context, response });
      return response;
    });
  }
  clear() {
    return this.api.request({ url: "/api/" + mt`ai`, method: "DELETE" }).then(() => this.emit(mt`ai:d`, this.api.token));
  }
}
class Analytics extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  ipTrace(ip) {
    if (!ip) throw new Error("Cannot trace, missing IP");
    return this.api.request({ url: `/api/` + mt`analytics/trace/${ip}` }).then((resp) => {
      this.emit(mt`analytics/trace/${ip}:r`, resp);
      return resp;
    });
  }
}
class Auth extends re {
  constructor(api, opts = {}) {
    super();
    __publicField(this, "api");
    __publicField(this, "_user");
    __publicField(this, "enableTotp", this.resetTotp);
    this.opts = opts;
    this.api = typeof api == "string" ? new Api(api) : api;
    this.opts = {
      loginUrl: this.api.url + "/ui/#/login",
      ...this.opts
    };
    this.api.addInterceptor((resp, next) => {
      const blacklist = [
        "/api/auth/login",
        "/api/auth/password",
        "/api/auth/totp"
      ];
      if (resp.status == 401 && !blacklist.find((url) => resp.url.includes(url)))
        this.emit(mt`auth/session-expired:d`, this.api.token);
      next();
    });
    if (this.api.token) this.session(this.api.token, true);
    else this.user = null;
    this.api.on("api/token", (event, token) => {
      if (token) this.session(token, true).catch(() => {
      });
      else this.user = null;
    });
  }
  get user() {
    return this._user;
  }
  set user(user) {
    if (!O(this.user, user)) {
      this._user = user ? user : null;
      this.emit(mt`auth/user:u`, this._user);
    }
  }
  knownHost(host = location.origin) {
    if (host.startsWith("/")) return Promise.resolve();
    return this.api.request({ url: `/api/auth/known-host?host=${encodeURI(new URL(host).origin)}` });
  }
  login(username, password, totp) {
    if (!username || !password) throw new Error("Cannot login, missing username or password");
    return this.api.request({
      url: "/api/auth/login",
      headers: { Authorization: void 0 },
      method: "POST",
      body: {
        username: username.trim(),
        password: password.trim(),
        totp
      }
    }).then(async (resp) => {
      this.api.token = (resp == null ? void 0 : resp.token) || null;
      const user = await this.once("auth/user");
      this.emit(mt`auth/login/${username}:u`, user);
      return user;
    });
  }
  loginRedirect(host = location.origin) {
    return new Promise((res, rej) => {
      var _a;
      const win = window.open(encodeURI(`${(_a = this.opts) == null ? void 0 : _a.loginUrl}?redirect=postmessage&host=${host}`), "_blank");
      if (!win) return rej("Unable to open login");
      const origin = new URL(this.opts.loginUrl).origin;
      win.addEventListener("message", (event) => {
        const data = (event == null ? void 0 : event.data) || {};
        if (event.origin != data.sender || data.sender != origin) return;
        if (!data.token) return rej("Unknown response from login");
        this.api.token = event.data.token;
        res(event.data.token);
        win.close();
      });
    });
  }
  logout() {
    this.emit(mt`auth/logout:d`, this.user);
    this.api.token = null;
    this.user = null;
  }
  async register(u) {
    var _a;
    if (!u.username || !u.password) throw new Error("Cannot register user, missing username or password");
    const user = await this.api.request({ url: "/api/auth/register", body: { ...u } });
    if ((_a = user == null ? void 0 : user.image) == null ? void 0 : _a.startsWith("/")) user.image = `${this.api.url}${user.image}?token=${this.api.token}`;
    this.emit(mt`auth/register:c`, user);
    return user;
  }
  reset(emailOrPass, token) {
    if (!emailOrPass) throw new Error("Cannot reset password, missing email or token");
    return this.api.request({
      url: "/api/auth/reset",
      headers: { "Authorization": token ? `Bearer ${token}` : void 0 },
      body: {
        email: token ? void 0 : emailOrPass,
        password: token ? emailOrPass : void 0
      }
    }).then(() => {
      this.emit(mt`auth/reset:${token ? "u" : "c"}`, token || emailOrPass);
    });
  }
  async session(token, set = false) {
    if (!token) token = this.api.token;
    const session = await this.api.request({
      url: "/api/auth/session",
      headers: token ? { "Authorization": `Bearer ${token}` } : void 0
    });
    this.emit(mt`auth/session:r`, session);
    if (set) {
      this.api.token = token;
      if (session == null ? void 0 : session.user) session.user.image = `${this.api.url}${session.user.image}?token=${this.api.token}`;
      this.user = (session == null ? void 0 : session.user) || null;
      if (session) this.emit(mt`auth/login:c`, session.user);
    }
    return session;
  }
  async updatePassword(username, password, oldPassword) {
    if (!username || !password) throw new Error("Cannot update password, missing username or password");
    return this.api.request({
      url: "/api/auth/password",
      body: { username, password, oldPassword }
    }).then((resp) => {
      this.emit(mt`auth/reset:u`, resp == null ? void 0 : resp.token);
      if (resp == null ? void 0 : resp.token) this.api.token = resp.token;
    });
  }
  // TOTP ============================================================================================================
  disableTotp(username) {
    return this.api.request({ url: `/api/auth/totp/${username}`, method: "DELETE" });
  }
  resetTotp(username) {
    return this.api.request({ url: `/api/auth/totp/${username}`, method: "POST" });
  }
  setupTotp(username, method = "app", totp) {
    return this.api.request({ url: `/api/auth/totp/${username}`, body: ot({
      method,
      totp
    }) });
  }
}
class Client extends re {
  constructor(settings) {
    super();
    __publicField(this, "_platform");
    __publicField(this, "_pwa");
    this.settings = settings;
  }
  get mobile() {
    return ["android", "ios"].includes(this.platform);
  }
  get platform() {
    if (!this._platform) {
      const userAgent = navigator.userAgent || navigator.vendor;
      if (/windows/i.test(userAgent)) this._platform = "windows";
      else if (/android/i.test(userAgent)) this._platform = "android";
      else if (/iPad|iPhone|iPod/.test(userAgent)) this._platform = "ios";
      else if (/macintosh|mac os x/i.test(userAgent)) this._platform = "mac";
      else if (/linux/i.test(userAgent)) this._platform = "linux";
      else this._platform = "unknown";
    }
    return this._platform;
  }
  get pwa() {
    if (this._pwa == null)
      this._pwa = window.matchMedia("(display-mode: standalone)").matches || (navigator == null ? void 0 : navigator.standalone) || document.referrer.includes("android-app://");
    return this._pwa;
  }
  async inject(reload = false, firstLoad = true) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    let settings = this.settings.cache;
    if (firstLoad) this.settings.all(false, reload).then(() => this.inject(false, false)).catch(() => {
    });
    if (!document.querySelector('meta[name="mobile-web-app-capable"]')) {
      const meta = document.createElement("meta");
      meta.name = "mobile-web-app-capable";
      meta.content = "yes";
      document.head.append(meta);
    }
    if (!document.querySelector('meta[name="apple-mobile-web-app-status-bar-style"]')) {
      const meta = document.createElement("meta");
      meta.name = "apple-mobile-web-app-status-bar-style";
      meta.content = "default";
      document.head.append(meta);
    }
    if (!document.querySelector('meta[name="apple-mobile-web-app-title"]')) {
      const meta = document.createElement("meta");
      meta.name = "apple-mobile-web-app-title";
      meta.content = settings["title"];
      document.head.append(meta);
    }
    if (!document.querySelector('link[rel="apple-touch-icon"]')) {
      const meta = document.createElement("link");
      meta.rel = "apple-touch-icon";
      meta.href = settings["logo"];
      document.head.append(meta);
    }
    if (!document.querySelector('link[rel="apple-touch-startup-image"]')) {
      const meta = document.createElement("link");
      meta.rel = "apple-touch-startup-image";
      meta.href = settings["logo"];
      document.head.append(meta);
    }
    window.document.body.classList.add(((_a = settings["theme"]) == null ? void 0 : _a.darkMode) ? "theme-dark" : "theme-light");
    window.document.body.classList.remove(((_b = settings["theme"]) == null ? void 0 : _b.darkMode) ? "theme-light" : "theme-dark");
    if (settings["title"])
      window.document.querySelectorAll(".momentum-title").forEach((el) => el.innerText = settings["title"]);
    if (settings["description"])
      window.document.querySelectorAll(".momentum-description").forEach((el) => el.innerText = settings["description"]);
    if (settings.version)
      window.document.querySelectorAll(".momentum-version").forEach((el) => el.innerText = settings["version"]);
    if (settings["logo"]) {
      window.document.querySelectorAll(".momentum-logo").forEach((el) => {
        el.src = settings["logo"];
        el.href = settings["logo"];
      });
    }
    if (settings["theme"]) {
      let style = window.document.querySelector("#momentum-theme");
      if (!style) {
        style = window.document.createElement("style");
        style.id = "momentum-theme";
        window.document.head.append(style);
      }
      style.innerHTML = `
			:root {
				--theme-bg-primary: ${(_c = settings["theme"]) == null ? void 0 : _c.background};
				--theme-bg-secondary: ${((_d = settings["theme"]) == null ? void 0 : _d.darkMode) ? "#2e2e2e" : "#ffffff"};
				--theme-primary: ${(_e = settings["theme"]) == null ? void 0 : _e.primary};
				--theme-secondary: ${(_f = settings["theme"]) == null ? void 0 : _f.secondary};
				--theme-text: ${((_g = settings["theme"]) == null ? void 0 : _g.darkMode) ? "#ffffff" : "#000000"};
				--theme-muted: ${((_h = settings["theme"]) == null ? void 0 : _h.darkMode) ? "#cccccc" : "#6c757d"};
			}`;
    }
    if (settings["pwa"]) {
      const link = window.document.createElement("link");
      link.setAttribute("rel", "manifest");
      link.setAttribute("href", this.settings.api.url + "/manifest.json");
      window.document.head.append(link);
      setTimeout(() => {
        const dismissed = !!localStorage.getItem("momentum:install-prompt");
        if (!dismissed && !this.pwa && this.mobile) this.pwaPrompt();
      }, 500);
    }
    this.emit(mt`client/inject:c`, this.platform);
  }
  pwaPrompt(platform) {
    const url = this.settings.api.url;
    const settings = this.settings.cache;
    const android = (platform || this.platform) == "android";
    let style = document.querySelector("style.momentum-pwa");
    if (!style) {
      style = document.createElement("style");
      style.innerHTML = `
		.momentum-pwa-prompt-backdrop {
			position: fixed;
			display: relative;
			left: 0;
			top: 0;
			right: 0;
			bottom: 0;
			background: rgba(0,0,0,.5);
			z-index: 9999;
			animation: fadeIn 0.5s ease-in-out forwards;
			opacity: 0;
		}
		.momentum-pwa-prompt-backdrop.exit {
			animation: fadeOut 0.5s ease-in-out forwards !important;
		}
		.momentum-pwa-prompt {
			position: fixed;
			background: #fff;
			color: black;
			bottom: 0;
			left: 50%;
			width: min(100vw, 450px);
			transform: translate(-50%, 0);
			animation: slideUp 0.5s ease-in-out forwards;
		}
		.momentum-pwa-prompt.exit {
			animation: slideDown 0.5s ease-in-out forwards !important;
		}
		.momentum-pwa-prompt img {
			width: 18px;
			height: 18px;
		}
		.momentum-pwa-prompt h1 {
			font-size: 1.25rem;
			font-weight: bold;
		}
		.momentum-pwa-prompt-close {
			position: absolute;
			right: 5px;
			top: 10px;
			background: transparent;
			border: none;
			cursor: pointer;
		}

		@keyframes fadeIn {
		  from { opacity: 0; }
		  to { opacity: 1; }
		}
		@keyframes fadeOut {
		  from { opacity: 1; }
		  to { opacity: 0; }
		}

		@keyframes slideUp {
		  from { transform: translate(-50%, 100%); }
		  to { transform: translate(-50%, 0); }
		}
		@keyframes slideDown {
		  from { transform: translate(-50%, 0); }
		  to { transform: translate(-50%, 100%); }
		}
		`;
      document.head.append(style);
    }
    const backdrop = document.createElement("div");
    backdrop.classList.add("momentum-pwa-prompt-backdrop");
    const prompt = document.createElement("div");
    prompt.classList.add("momentum-pwa-prompt");
    prompt.innerHTML = `
			<div style="display: flex; padding: 1rem; align-items: center">
			  <img src="${url}${settings.logo}" alt="Logo" style="height: 30px; width: auto; margin-right: .5rem;" />
			  <h1 style="margin: 0">Install ${settings.title}</h1>
			</div>
			<div style="display: flex; flex-direction: column; align-items: center">
			  <div style="border-top: 2px solid #00000020; border-bottom: 2px solid #00000020; padding: 0 1rem">
				<p style="margin-top: 1rem; text-align: center">This website can be installed as an App! Add it to your home screen for quick access & fullscreen use.</p>
			  </div>
			  <table style="margin: 1.5rem 0">
				<tr>
				  <td style="width: 50px; text-align: center">
				    ${android ? '<svg xmlns="http://www.w3.org/2000/svg" height="24px" viewBox="0 -960 960 960" width="24px" fill="black" style="transform: scale(1.5)"><path d="M480-160q-33 0-56.5-23.5T400-240q0-33 23.5-56.5T480-320q33 0 56.5 23.5T560-240q0 33-23.5 56.5T480-160Zm0-240q-33 0-56.5-23.5T400-480q0-33 23.5-56.5T480-560q33 0 56.5 23.5T560-480q0 33-23.5 56.5T480-400Zm0-240q-33 0-56.5-23.5T400-720q0-33 23.5-56.5T480-800q33 0 56.5 23.5T560-720q0 33-23.5 56.5T480-640Z"/></svg>' : '<svg viewBox="0 0 566 670" xmlns="http://www.w3.org/2000/svg" fill="#0B76FC" height="40px"><path d="M255 12c4-4 10-8 16-8s12 3 16 8l94 89c3 4 6 7 8 12 2 6 0 14-5 19-7 8-20 9-28 2l-7-7-57-60 2 54v276c0 12-10 22-22 22-12 1-24-10-23-22V110l1-43-60 65c-5 5-13 8-21 6a19 19 0 0 1-16-17c-1-7 2-13 7-18l95-91z" /><path d="M43 207c16-17 40-23 63-23h83v46h-79c-12 0-25 3-33 13-8 9-10 21-10 33v260c0 13 0 27 6 38 5 12 18 18 30 19l14 1h302c14 0 28 0 40-8 11-7 16-21 16-34V276c0-11-2-24-9-33-8-10-22-13-34-13h-78v-46h75c13 0 25 1 37 4 16 4 31 13 41 27 11 17 14 37 14 57v280c0 20-3 41-15 58a71 71 0 0 1-45 27c-11 2-23 3-34 3H109c-19-1-40-4-56-15-14-9-23-23-27-38-4-12-5-25-5-38V270c1-22 6-47 22-63z" /></svg>'}
				  </td>
				  <td>
					<p style="margin: 1rem 0">1) ${android ? "Open the dropdown menu" : 'Press the "Share" button'}</p>
				  </td>
				</tr>
				<tr>
				  <td style="width: 50px; text-align: center">
				    ${android ? '<svg xmlns="http://www.w3.org/2000/svg" height="24px" viewBox="0 -960 960 960" width="24px" fill="black" style="transform: scale(-1.5, 1.5)"><path d="M280-40q-33 0-56.5-23.5T200-120v-720q0-33 23.5-56.5T280-920h280v80H280v40h280v80H280v480h400v-80h80v200q0 33-23.5 56.5T680-40H280Zm0-120v40h400v-40H280Zm440-240L520-600l56-56 104 104v-288h80v288l104-104 56 56-200 200ZM280-800v-40 40Zm0 640v40-40Z"/></svg>' : '<svg viewBox="0 0 578 584" xmlns="http://www.w3.org/2000/svg" fill="black" height="34px"><path d="M101 35l19-1h333c12 0 23 0 35 3 17 3 34 12 44 27 13 16 16 38 16 58v329c0 19 0 39-8 57a65 65 0 0 1-37 37c-18 7-38 7-57 7H130c-21 1-44 0-63-10-14-7-25-20-30-34-6-15-8-30-8-45V121c1-21 5-44 19-61 13-16 33-23 53-25m7 46c-10 1-19 6-24 14-7 8-9 20-9 31v334c0 12 2 25 10 34 9 10 23 12 35 12h336c14 1 30-3 38-15 6-9 8-20 8-31V125c0-12-2-24-10-33-9-9-22-12-35-12H121l-13 1z" /><path d="M271 161c9-11 31-10 38 4 3 5 3 11 3 17v87h88c7 0 16 1 21 7 6 6 7 14 6 22a21 21 0 0 1-10 14c-5 4-11 5-17 5h-88v82c0 7-1 15-6 20-10 10-29 10-37-2-3-6-4-13-4-19v-81h-87c-8-1-17-3-23-9-5-6-6-15-4-22a21 21 0 0 1 11-14c6-3 13-3 19-3h84v-88c0-7 1-14 6-20z" /></svg>'}
				  </td>
				  <td>
					<p style="margin: 1rem 0">2) Press "Add to Home Screen"</p>
				  </td>
				</tr>
			  </table>
			</div>`;
    const close = document.createElement("button");
    close.classList.add("momentum-pwa-prompt-close");
    close.innerText = "X";
    close.onclick = () => {
      prompt.classList.add("exit");
      backdrop.classList.add("exit");
      localStorage.setItem("momentum:install-prompt", "dismissed");
      setTimeout(() => {
        prompt.remove();
        backdrop.remove();
        this.emit(mt`client/pwa:d`, platform);
      }, 500);
    };
    prompt.append(close);
    backdrop.append(prompt);
    document.body.append(backdrop);
    this.emit(mt`client/pwa:c`, platform);
  }
}
class Data extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  create(collection, document2) {
    if (!collection || !document2) throw new Error("Cannot create document, missing collection or document");
    return this.api.request({
      url: `/api/` + mt`data/${collection}`,
      method: "POST",
      body: document2
    }).then((resp) => {
      this.emit(mt`data/${collection}:c`, resp);
      return resp;
    });
  }
  delete(collection, id) {
    if (!collection || !id) throw new Error("Cannot delete document, missing collection or ID");
    return this.api.request({
      url: `/api/` + mt`data/${collection}/${id}`,
      method: "DELETE"
    }).then(() => this.emit(mt`data/${collection}/${id}:d`, id));
  }
  read(collection, id) {
    if (!collection) throw new Error("Cannot read documents, missing collection");
    return this.api.request({ url: `/api/` + mt`data/${collection}/${id}` }).then((resp) => {
      this.emit(mt`data/${collection}/${id}:r`, collection, resp);
      return resp;
    });
  }
  update(collection, document2, append = true) {
    if (!collection || !document2) throw new Error("Cannot update document, missing collection or document");
    if (!document2._id) return this.create(collection, document2);
    return this.api.request({
      url: `/api/` + mt`data/${collection}/${document2._id}`,
      method: append ? "PATCH" : "PUT",
      body: document2
    }).then((resp) => {
      this.emit(mt`data/${collection}/${document2._id}:u`, resp);
      return resp;
    });
  }
  raw(collection, query) {
    if (!collection || !query) throw new Error("Cannot execute raw query, missing collection or query");
    const mode = query.operand.startsWith("find") ? "r" : query.operand == "insert" ? "c" : query.operand.startsWith("delete") ? "d" : "u";
    return this.api.request({ url: `/api/` + mt`data/${collection}` + "?raw", body: query }).then((resp) => {
      this.emit(mt`data/${collection}:${mode}`, resp);
      return resp;
    });
  }
  // Schema ==========================================================================================================
  deleteSchema(path) {
    if (!path) throw new Error("Cannot delete schema, missing collection path");
    return this.api.request({ url: `/api/` + mt`schema/${path}`, method: "DELETE" }).then(() => this.emit(mt`schema/${path}:d`, path));
  }
  readSchema(pathOrTree) {
    return this.api.request({ url: "/api/" + mt`schema/${typeof pathOrTree == "string" ? pathOrTree : ""}` + (pathOrTree === true ? `?tree=${pathOrTree}` : "") }).then((resp) => {
      this.emit(mt`schema/${typeof pathOrTree == "string" ? pathOrTree : ""}:r`, resp);
      return resp;
    });
  }
  updateSchema(schema) {
    if (!schema.path) throw new Error("Cannot update schema, missing collection path");
    return this.api.request({ url: "/api/" + mt`schema/${schema.path}`, body: schema }).then((resp) => {
      this.emit(mt`schema/${schema.path}:${schema._id ? "u" : "c"}`, resp);
      return resp;
    });
  }
}
class Email extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  send(email) {
    var _a;
    if (!email.to && !email.bcc || !email.body) throw new Error("Cannot send email, missing address or body");
    return this.api.request({ url: "/api/" + mt`email/${(_a = email.body) == null ? void 0 : _a.template}`, body: email }).then((response) => {
      var _a2;
      this.emit(mt`email/${(_a2 = email.body) == null ? void 0 : _a2.template}:c`, { email, response });
      return response;
    });
  }
}
class Groups extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    __publicField(this, "cache", new Tt("name"));
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  async all(reload) {
    if (!reload && this.cache.complete) return this.cache.all();
    return this.api.request({ url: `/api/` + mt`groups` }).then((resp) => {
      this.cache.addAll(resp);
      this.emit(mt`groups:r`, resp || []);
      return resp;
    });
  }
  delete(name) {
    if (!name) throw new Error("Cannot delete group, missing name");
    return this.api.request({
      url: `/api/` + mt`groups/${name}`,
      method: "DELETE"
    }).then(() => {
      this.cache.delete(name);
      this.emit(mt`groups/${name}:d`);
    });
  }
  create(group) {
    if (!group.name) throw new Error("Cannot create group, missing name");
    return this.api.request({
      url: `/api/` + mt`groups/${group.name}`,
      method: "POST",
      body: group
    }).then((resp) => {
      this.cache.add(resp);
      this.emit(mt`groups/${group.name}:c`, resp);
      return resp;
    });
  }
  async read(name, reload) {
    if (!name) throw new Error("Cannot read group, missing name");
    if (!reload && this.cache.get(name)) return this.cache.get(name);
    return this.api.request({ url: `/api/` + mt`groups/${name}` }).then((resp) => {
      this.cache.add(resp);
      this.emit(mt`groups/${name}:r`, resp);
      return resp;
    });
  }
  update(group) {
    if (!group.name) throw new Error("Cannot update group, missing name");
    return this.api.request({
      url: `/api/` + mt`groups/${group.name}`,
      method: "PATCH",
      body: group
    }).then((resp) => {
      this.cache.add(resp);
      this.emit(mt`groups/${group.name}:u`, resp);
      return resp;
    });
  }
}
class Logger extends re {
  constructor(api, channel, logLevel) {
    super();
    __publicField(this, "api");
    __publicField(this, "console", {
      debug: console.debug,
      log: console.log,
      info: console.info,
      warn: console.warn,
      error: console.error
    });
    this.channel = channel;
    if (channel.toLowerCase() == "server") throw new Error('"Server" namespace is reserved');
    this.api = typeof api == "string" ? new Api(api) : api;
    if (logLevel != null && logLevel && logLevel != "NONE") {
      if (ft[logLevel] >= 0) {
        console.error = (...args) => {
          this.console.error(...args);
          this.error(...args);
        };
        window.addEventListener("unhandledrejection", async (event) => {
          var _a, _b, _c, _d;
          let log = ((_a = event.reason) == null ? void 0 : _a.stack) || event.reason;
          if ((_b = event.reason) == null ? void 0 : _b.url)
            log = `${event.reason.method} ${event.reason.url} -> ${event.reason.code}

${log}`;
          ((_c = event.reason) == null ? void 0 : _c.code) == null || ((_d = event.reason) == null ? void 0 : _d.code) >= 500 ? this.error(log) : this.warn(log);
        });
      }
      if (ft[logLevel] >= 1) {
        console.warn = (...args) => {
          this.console.warn(...args);
          this.warn(...args);
        };
      }
      if (ft[logLevel] >= 2) {
        console.info = (...args) => {
          this.console.info(...args);
          this.info(...args);
        };
      }
      if (ft[logLevel] >= 3) {
        console.log = (...args) => {
          this.console.log(...args);
          this.log(...args);
        };
      }
      if (ft[logLevel] >= 4) {
        console.debug = (...args) => {
          this.console.debug(...args);
          this.debug(...args);
        };
      }
    }
  }
  buildLog(level, log) {
    return {
      time: (/* @__PURE__ */ new Date()).getTime(),
      level,
      log,
      ctx: {
        cores: navigator.hardwareConcurrency,
        mem: navigator == null ? void 0 : navigator.deviceMemory,
        res: [window.innerWidth, window.innerHeight],
        url: location.href
      }
    };
  }
  create(log, channel = this.channel) {
    if (channel.toLowerCase() == "server") throw new Error('"Server" namespace is reserved');
    return this.api.request({ url: `/api/` + mt`logs/${channel}`, body: log }).then(() => this.emit(mt`logs/${channel}:c`, log)).catch(() => {
    });
  }
  channels() {
    return this.api.request({ url: "/api/" + mt`logs/channels` });
  }
  delete(channel = this.channel) {
    return this.api.request({ url: `/api/` + mt`logs/${channel}`, method: "DELETE" }).then(() => this.emit(mt`logs/${channel}:d`));
  }
  read(channel = this.channel) {
    return this.api.request({ url: `/api/` + mt`logs/${channel}` }).then((logs) => {
      this.emit(mt`logs/${channel}:r`, logs);
      return logs;
    });
  }
  // Console =========================================================================================================
  debug(log, channel = this.channel) {
    return this.create(this.buildLog(ft.DEBUG, log), channel);
  }
  log(log, channel = this.channel) {
    return this.create(this.buildLog(ft.LOG, log), channel);
  }
  info(log, channel = this.channel) {
    return this.create(this.buildLog(ft.INFO, log), channel);
  }
  warn(log, channel = this.channel) {
    return this.create(this.buildLog(ft.WARN, log), channel);
  }
  error(log, channel = this.channel) {
    return this.create(this.buildLog(ft.ERROR, log), channel);
  }
}
class Payments extends re {
  constructor(api, secret) {
    super();
    __publicField(this, "api");
    __publicField(this, "stripe");
    this.api = typeof api == "string" ? new Api(api) : api;
    const setup = (retry = 1) => {
      try {
        if (!Stripe) throw new Error("Stripe not added");
        this.stripe = Stripe(secret);
      } catch (err) {
        if (retry > 0) setTimeout(() => setup(retry--), 250);
        else console.warn("Stripe failed, did you add the library & setup your API key?", err);
      }
    };
    setup();
  }
  async create(amount, custom = {}) {
    if (!amount) throw new Error("Please specify a valid amount`");
    const request = await this.api.request({ url: "/api/payments", body: {
      amount,
      custom
    } });
    this.emit(mt`payments:c`, request.data.clientSecret);
    return request.data.clientSecret;
  }
  async createForm(element, amount, custom) {
    const token = await this.create(amount, custom);
    const form = this.stripe.elements({ clientSecret: token });
    form.create("payment").mount(element);
    return () => this.stripe.confirmPayment({
      elements: form,
      redirect: "if_required",
      confirmParams: { return_url: location.origin }
    });
  }
  async history(username) {
    const history = await this.api.request({ url: `/api/` + mt`payments/${username}` });
    this.emit(mt`payments/${username}:r`, history);
    return history;
  }
}
class Pdf extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  createPdf(body, options) {
    return this.api.request({ url: `/api/` + mt`pdf`, body: { ...body, options }, decode: false }).then(async (resp) => {
      const blob = await resp.blob();
      if (options == null ? void 0 : options.download) {
        let filename = (options == null ? void 0 : options.filename) || kt();
        if (!filename.endsWith(".pdf")) filename += ".pdf";
        const url = URL.createObjectURL(blob);
        lt(url, filename);
        URL.revokeObjectURL(url);
      }
      this.emit(mt`pdf:c`, blob);
      return blob;
    });
  }
  fromHtml(html, options = {}) {
    if (!html) throw new Error("Cannot create PDF, missing HTML");
    return this.createPdf({ html }, options);
  }
  fromTemplate(template, data, options = {}) {
    if (!template) throw new Error("Cannot create PDF, missing template");
    return this.createPdf({ template, data }, options);
  }
  fromUrl(url, options = {}) {
    if (!url) throw new Error("Cannot create PDF, missing URL");
    return this.createPdf({ url }, options);
  }
}
const _Socket = class _Socket {
  constructor(api) {
    __publicField(this, "api");
    __publicField(this, "url");
    __publicField(this, "connection");
    __publicField(this, "open", false);
    this.api = typeof api == "string" ? new Api(api) : api;
    this.url = this.api.url.replace("http", "ws");
    this.api.on("api/token", () => this.connect());
    this.connect();
  }
  close() {
    var _a;
    if (this.open) console.debug("Disconnected from Momentum");
    this.open = false;
    (_a = this.connection) == null ? void 0 : _a.close();
    this.connection = void 0;
  }
  connect() {
    if (this.open) this.close();
    if (navigator.onLine) {
      this.connection = new WebSocket(this.url + (this.api.token ? `?token=${this.api.token}` : ""));
      this.connection.onclose = this.close;
      this.connection.onmessage = this.handle;
      this.connection.onopen = () => {
        this.open = true;
        clearTimeout(timeout);
        console.debug("Connected to Momentum");
      };
    }
    const timeout = setTimeout(() => {
      if (this.open) return;
      this.close();
      this.connect();
    }, _Socket.pollingSpeed);
  }
  handle(...args) {
    console.log(args);
  }
  send(channel, payload) {
    var _a;
    (_a = this.connection) == null ? void 0 : _a.send(JSON.stringify({
      token: this.api.token,
      channel,
      payload
    }));
  }
};
__publicField(_Socket, "pollingSpeed", 3e4);
let Socket = _Socket;
class Storage extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  copy(source, destination) {
    if (!source || !destination) throw new Error("Cannot copy file or folder, missing source or destination");
    return this.api.request({ url: "/api/" + mt`storage/${destination}`, body: { from: source } }).then((response) => {
      this.emit(mt`storage/${destination}:c`, response);
      return response;
    });
  }
  delete(path) {
    if (!path) throw new Error("Cannot delete file or folder, missing path");
    return this.api.request({ url: "/api/" + mt`storage/${path}`, method: "DELETE" }).then(() => {
      this.emit(mt`storage/${path}:d`, path);
    });
  }
  download(path, opts = {}) {
    if (!path) throw new Error("Cannot download file, missing path");
    return this.api.request({ ...opts, url: "/api/" + mt`storage/${path}`, decode: false }).then(async (response) => {
      const blob = await response.blob();
      const name = opts.downloadAs || path.split("/").pop();
      this.emit(mt`storage/${path}:r`, blob);
      Dt(blob, name);
      return response;
    });
  }
  list(path) {
    if (!path) path = "/";
    return this.api.request({ url: "/api/" + mt`storage/${path}` + "?list" }).then((resp) => {
      this.emit(mt`storage/${path}:r`, resp);
      return resp;
    });
  }
  open(path, target = "_blank") {
    if (!path) throw new Error("Cannot download file, missing path");
    const link = `${this.api.url}/api/` + mt`storage/${path}` + (this.api.token ? `?token=${this.api.token}` : "");
    if (!target) return link;
    this.emit(mt`storage/${path}:r`, path);
    return window.open(link, target);
  }
  mkdir(path) {
    if (!path) throw new Error("Cannot make directory, missing path");
    return this.api.request({ url: "/api/" + mt`storage/${path}`, body: { directory: true } }).then((resp) => {
      this.emit(mt`storage/${path}:c`, resp);
      return resp;
    });
  }
  move(source, destination) {
    if (!source || !destination) throw new Error("Cannot move file or folder, missing source or destination");
    if (source == destination) return this.list(destination);
    return this.api.request({ url: "/api/" + mt`storage/${source}`, method: "PATCH", body: { move: destination } }).then((response) => {
      this.emit(mt`storage/${source}:u`, response);
      return response;
    });
  }
  upload(files, opts) {
    return new x(async (res, rej, prog) => {
      if (!files) files = await Mt(typeof opts == "object" ? opts : void 0);
      if (!files || Array.isArray(files) && !files.length) return [];
      const path = (opts && typeof opts == "object" ? opts == null ? void 0 : opts.path : opts) || "/";
      return Pt({
        url: `${this.api.url}/api/` + mt`storage/${path}`,
        files: m(files),
        headers: this.api.headers
      }).onProgress((p) => {
        prog(p);
      }).then((resp) => {
        this.emit(mt`storage/${path}:c`, resp);
        res(resp);
      }).catch((err) => rej(err));
    });
  }
}
class Users extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    __publicField(this, "cache", new Tt("username"));
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  async all(reload) {
    if (!reload && this.cache.complete) return this.cache.all();
    return this.api.request({ url: "/api/" + mt`users` }).then((resp) => {
      resp == null ? void 0 : resp.forEach((r) => {
        r.image = this.api.url + r.image + `?token=${this.api.token}`;
        return r;
      });
      this.cache.addAll(resp);
      this.emit(mt`users:r`, resp || []);
      return resp;
    });
  }
  delete(username) {
    if (!username) throw new Error("Cannot delete user, missing username");
    return this.api.request({
      url: "/api/" + mt`users/${username}`,
      method: "DELETE"
    }).then(() => {
      this.cache.delete(username);
      this.emit(mt`users/${username}:d`, username);
    });
  }
  async read(username, reload) {
    if (!username) throw new Error("Cannot read user, missing username");
    if (!reload && this.cache.get(username)) return this.cache.get(username);
    return this.api.request({ url: "/api/" + mt`users/${username}` }).then((resp) => {
      if (resp) {
        resp.image = this.api.url + resp.image + `?token=${this.api.token}`;
        this.cache.add(resp);
      }
      this.emit(mt`users/${username}:r`, resp);
      return resp;
    });
  }
  update(user) {
    if (!user.username) throw new Error("Cannot update user, missing username");
    return this.api.request({
      url: `/api/` + mt`users/${user.username}`,
      method: "PATCH",
      body: user
    }).then((resp) => {
      if (resp) {
        resp.image = this.api.url + resp.image + `?token=${this.api.token}`;
        this.cache.add(resp);
      }
      this.emit(mt`users/${user.username}:${resp._id ? "u" : "c"}`, resp);
      return resp;
    });
  }
  uploadImage(username, file) {
    if (!username || !file) throw new Error("Cannot update user image, missing username or file");
    return Pt({
      url: this.api.url + `/api/` + mt`users/${username}/image`,
      files: [file],
      headers: this.api.headers
    });
  }
}
class Settings extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    __publicField(this, "cache");
    this.api = typeof api == "string" ? new Api(api) : api;
    this.cache = new Tt("key", { storageKey: `momentum:settings:${this.api.host}` });
    this.api.on("api/token", () => this.all(false, true));
  }
  async all(detailed, reload) {
    if (!reload && !detailed && this.cache.complete) return this.cache;
    return this.api.request({ url: `/api/` + mt`settings` + (detailed ? "?detailed" : "") }).then((resp) => {
      this.cache.clear();
      if (resp) Object.keys(resp).forEach((key) => this.cache.set(key, detailed ? resp[key].value : resp[key]));
      this.cache.complete = true;
      this.emit(mt`settings:r`, resp || []);
      return resp;
    });
  }
  delete(key) {
    if (!key) throw new Error("Cannot delete setting, missing key");
    return this.api.request({ url: `/api/` + mt`settings/${key}`, method: "DELETE" }).then(() => {
      this.cache.delete(key);
      this.emit(mt`settings/${key}:d`, key);
    });
  }
  read(key, reload = false) {
    if (!key) throw new Error("Cannot read setting, missing key");
    if (!reload && this.cache.get(key)) return this.cache.get(key);
    return this.api.request({ url: `/api/` + mt`settings/${key}` }).then((variable) => {
      if (variable) this.cache.set(variable.key, variable.value);
      this.emit(mt`settings/${key}:r`, variable);
      return variable;
    });
  }
  update(variable) {
    if (!variable.key) throw new Error("Cannot update setting, missing key");
    return this.api.request({ url: `/api/` + mt`settings/${variable.key}`, body: variable }).then((variable2) => {
      if (variable2) this.cache.set(variable2.key, variable2.value);
      this.emit(`/api/` + mt`settings/${variable2.key}:${variable2._id ? "u" : "c"}`, variable2);
      return variable2;
    });
  }
}
class Static extends re {
  constructor(api) {
    super();
    __publicField(this, "api");
    this.api = typeof api == "string" ? new Api(api) : api;
  }
  delete(path) {
    if (!path) throw new Error("Cannot delete static asset, missing path");
    return this.api.request({ url: `/api/` + mt`static/${path}`, method: "DELETE" }).then(() => {
      this.emit(mt`static/${path}:d`, path);
    });
  }
  upload(files, path = "/") {
    if (!files) throw new Error("Cannot upload static assets, missing file");
    return new x(async (res, rej, prog) => {
      return Pt({
        url: this.api.url + "/api/" + mt`static/${path}`,
        files: m(files),
        headers: this.api.headers
      }).onProgress((p) => {
        prog(p);
      }).then((resp) => {
        this.emit(mt`static/${path}:c`, resp);
        res(resp);
      }).catch((err) => rej(err));
    });
  }
}
class Momentum extends re {
  constructor(url, opts) {
    super();
    __publicField(this, "api");
    __publicField(this, "actions");
    __publicField(this, "ai");
    __publicField(this, "analytics");
    __publicField(this, "auth");
    __publicField(this, "client");
    __publicField(this, "data");
    __publicField(this, "email");
    __publicField(this, "groups");
    __publicField(this, "logger");
    __publicField(this, "payments");
    __publicField(this, "pdf");
    __publicField(this, "settings");
    __publicField(this, "socket");
    __publicField(this, "static");
    __publicField(this, "storage");
    __publicField(this, "users");
    this.api = new Api(url, opts);
    this.actions = new Actions(this.api);
    this.ai = new Ai(this.api);
    this.analytics = new Analytics(this.api);
    this.auth = new Auth(this.api, { loginUrl: opts == null ? void 0 : opts.loginUrl });
    this.data = new Data(this.api);
    this.email = new Email(this.api);
    this.groups = new Groups(this.api);
    this.logger = new Logger(this.api, (opts == null ? void 0 : opts.app) || "client", opts == null ? void 0 : opts.logLevel);
    if (opts == null ? void 0 : opts.stripeSecret) this.payments = new Payments(this.api, opts.stripeSecret);
    this.pdf = new Pdf(this.api);
    this.settings = new Settings(this.api);
    if (opts == null ? void 0 : opts.socket) this.socket = new Socket(this.api);
    this.static = new Static(this.api);
    this.storage = new Storage(this.api);
    this.client = new Client(this.settings);
    this.users = new Users(this.api);
    this.relayEvents(this.actions);
    this.relayEvents(this.ai);
    this.relayEvents(this.analytics);
    this.relayEvents(this.api);
    this.relayEvents(this.auth);
    this.relayEvents(this.client);
    this.relayEvents(this.data);
    this.relayEvents(this.email);
    this.relayEvents(this.groups);
    this.relayEvents(this.logger);
    if (this.payments) this.relayEvents(this.payments);
    this.relayEvents(this.pdf);
    this.relayEvents(this.settings);
    this.relayEvents(this.static);
    this.relayEvents(this.storage);
    this.relayEvents(this.users);
    this.users.on(`*`, () => {
      if (!this.auth.user) return;
      const cached = this.users.cache.get(this.auth.user.username);
      if (cached) this.auth.user = cached;
    });
  }
}
export {
  ActionType,
  Actions,
  Ai,
  Analytics,
  Api,
  Auth,
  Client,
  Data,
  Email,
  Groups,
  Logger,
  Momentum,
  ee as PE,
  mt as PES,
  y as PathEvent,
  re as PathEventEmitter,
  Payments,
  Pdf,
  Settings,
  Socket,
  Static,
  Storage,
  Users
};
